#ifndef OPTION_ASDL_H
#define OPTION_ASDL_H

namespace option_asdl {

#define ASDL_NAMES struct
ASDL_NAMES option_i {
  enum no_name {
  errexit = 1,
  nounset = 2,
  pipefail = 3,
  inherit_errexit = 4,
  nullglob = 5,
  verbose_errexit = 6,
  noexec = 7,
  xtrace = 8,
  verbose = 9,
  noglob = 10,
  noclobber = 11,
  posix = 12,
  vi = 13,
  emacs = 14,
  interactive = 15,
  hashall = 16,
  failglob = 17,
  extglob = 18,
  eval_unsafe_arith = 19,
  parse_dynamic_arith = 20,
  compat_array = 21,
  allow_csub_psub = 22,
  dynamic_scope = 23,
  redefine_module = 24,
  _running_trap = 25,
  _running_hay = 26,
  strict_argv = 27,
  strict_arith = 28,
  strict_array = 29,
  strict_control_flow = 30,
  strict_errexit = 31,
  strict_nameref = 32,
  strict_word_eval = 33,
  strict_tilde = 34,
  strict_glob = 35,
  parse_at = 36,
  parse_proc = 37,
  parse_brace = 38,
  parse_equals = 39,
  parse_paren = 40,
  parse_raw_string = 41,
  parse_triple_quote = 42,
  simple_word_eval = 43,
  dashglob = 44,
  expand_aliases = 45,
  command_sub_errexit = 46,
  process_sub_fail = 47,
  xtrace_rich = 48,
  xtrace_details = 49,
  sigpipe_status_ok = 50,
  redefine_proc = 51,
  parse_at_all = 52,
  parse_backslash = 53,
  parse_backticks = 54,
  parse_dollar = 55,
  parse_ignored = 56,
  parse_sh_assign = 57,
  parse_dparen = 58,
  parse_bare_word = 59,
  parse_sloppy_case = 60,
  simple_echo = 61,
  simple_eval_builtin = 62,
  simple_test_builtin = 63,
  parse_tea = 64,
  lastpipe = 65,
  progcomp = 66,
  histappend = 67,
  hostcomplete = 68,
  cmdhist = 69,
  assoc_expand_once = 70,
  autocd = 71,
  cdable_vars = 72,
  cdspell = 73,
  checkhash = 74,
  checkjobs = 75,
  checkwinsize = 76,
  complete_fullquote = 77,
  direxpand = 78,
  dirspell = 79,
  dotglob = 80,
  execfail = 81,
  extdebug = 82,
  extquote = 83,
  force_fignore = 84,
  globasciiranges = 85,
  globstar = 86,
  gnu_errfmt = 87,
  histreedit = 88,
  histverify = 89,
  huponexit = 90,
  interactive_comments = 91,
  lithist = 92,
  localvar_inherit = 93,
  localvar_unset = 94,
  login_shell = 95,
  mailwarn = 96,
  no_empty_cmd_completion = 97,
  nocaseglob = 98,
  nocasematch = 99,
  progcomp_alias = 100,
  promptvars = 101,
  restricted_shell = 102,
  shift_verbose = 103,
  sourcepath = 104,
  xpg_echo = 105,
  ARRAY_SIZE = 106,
  };
};

typedef int option_t;

ASDL_NAMES builtin_i {
  enum no_name {
  colon = 1,
  dot = 2,
  exec_ = 3,
  eval = 4,
  set = 5,
  shift = 6,
  times = 7,
  trap = 8,
  unset = 9,
  builtin = 10,
  readonly = 11,
  local = 12,
  declare = 13,
  typeset = 14,
  export_ = 15,
  test = 16,
  bracket = 17,
  true_ = 18,
  false_ = 19,
  try_ = 20,
  read = 21,
  echo = 22,
  printf = 23,
  mapfile = 24,
  readarray = 25,
  cd = 26,
  pushd = 27,
  popd = 28,
  dirs = 29,
  pwd = 30,
  source = 31,
  umask = 32,
  wait = 33,
  jobs = 34,
  fg = 35,
  bg = 36,
  shopt = 37,
  complete = 38,
  compgen = 39,
  compopt = 40,
  compadjust = 41,
  getopts = 42,
  command = 43,
  type = 44,
  hash = 45,
  help = 46,
  history = 47,
  alias = 48,
  unalias = 49,
  bind = 50,
  append = 51,
  write = 52,
  json = 53,
  pp = 54,
  hay = 55,
  haynode = 56,
  module = 57,
  use = 58,
  fork = 59,
  forkwait = 60,
  fopen = 61,
  shvar = 62,
  runproc = 63,
  boolstatus = 64,
  argparse = 65,
  describe = 66,
  push_registers = 67,
  cat = 68,
  ARRAY_SIZE = 69,
  };
};

typedef int builtin_t;


}  // namespace option_asdl

#endif  // OPTION_ASDL_H
